package edu.wpi.ari.glados;

import java.awt.Dimension;
import java.util.Vector;

import javax.vecmath.Vector3d;

import edu.wpi.ari.glados.gui.GUIManager;
import edu.wpi.ari.glados.ins.INSManager;
import edu.wpi.ari.glados.ins.INSObserver;
import edu.wpi.ari.glados.logging.Logger;
import edu.wpi.ari.glados.slam.SLAMFrame;
import edu.wpi.ari.glados.vision.VisionManager;
import edu.wpi.ari.glados.vision.VisionObserver;

public class GDriver implements VisionObserver, INSObserver{
	
	private VisionManager vm;
	private INSManager im;
	private SLAMFrame sf;
	
	private Logger log;
	
	private GUIManager gui;
	
	public GDriver() {
		
		vm = new VisionManager("crenshaw.wifi.wpi.edu", 7777, 8888, 30, new Dimension(240, 320));
		im = new INSManager("apple.wifi.wpi.edu", 4445);
		log = Logger.getLogger();
		
		sf = new SLAMFrame();
		
		gui = new GUIManager(this, sf);
		
		vm.connect();
		im.connect();
		
		vm.addListener(sf);
		vm.addListener(this);
		vm.addListener(log);
		im.addListener(sf);
		im.addListener(this);
		im.addListener(log);
		
		gui.initGUI(new Dimension(800, 400));
	}
	
	public static void main(String args[]) {
		new GDriver();
	}
	
	public VisionManager getVisionManager() {
		return vm;
	}
	
	public INSManager getINSManager() {
		return im;
	}

	public void VisionReceivedValues(Vector<Vector3d> points) {
		//System.out.println(points);
	}

	public void INSReceivedValues(Vector3d step, double yaw) {
		System.out.println("POSTINS: " + step.x + ":" + step.y + ":" + step.z + ":" + yaw);
	}
}
