/*
 * The STOCK System is developed by:
 * 
 * Team B.O.O.N.E.
 * 	Robert Breznak	(rbreznak)	
 * 	Jacky Leung		(jhwleung)
 * 	Josh Nedelka	(jnedelka)
 * 	Matthew Reiter	(mreiter)
 * 	Nathan Roy		(nroy)
 * 
 * of Worcester Polytechnic Institute,
 * 
 * for our dreamboat, Gary Pollice's OOA&D class.
 *
 * The program is provided under the terms and conditions of
 * the Eclipse Public License Version 1.0 ("EPL"). A copy of the EPL
 * is available at http://www.eclipse.org/org/documents/epl-v10.php.
 * The software is provided under the Copyright, 2007.
 */
package edu.wpi.ari.glados.gui;

/*
 * SplashDemo.java
 * 
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.Timer;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class GLaDOSSplash extends Frame implements ChangeListener {
	class LoadingSim implements ActionListener {
		public void actionPerformed(ActionEvent e) {

			progress.setValue(progress.getValue() + 1);

		}
	}

	private static final long serialVersionUID = 1L;
	private JProgressBar progress;

	private Runnable run;

	public GLaDOSSplash(Runnable r) {

		run = r;

		setLayout(new BorderLayout());

		ImageIcon icn;

		progress = new JProgressBar();
		progress.setMaximum(100);
		progress.setMinimum(0);
		progress.addChangeListener(this);

		icn = new ImageIcon(Toolkit.getDefaultToolkit().getImage("images/splash.png"));

		setBackground(new Color(255, 255, 255));
		setUndecorated(true);

		setSize(600, 311);

		add(new JLabel(icn), BorderLayout.CENTER);
		add(progress, BorderLayout.SOUTH);

		setVisible(true);

		setLocationRelativeTo(null);

		Timer timer = new Timer(10, new LoadingSim());
		timer.start();
	}

	public void stateChanged(ChangeEvent arg0) {
		if (progress.getValue() == 100) {
			run.run();
			this.dispose();
		}
	}

}
