/*
 * The STOCK System is developed by:
 * 
 * Team B.O.O.N.E.
 * 	Robert Breznak	(rbreznak)	
 * 	Jacky Leung		(jhwleung)
 * 	Josh Nedelka	(jnedelka)
 * 	Matthew Reiter	(mreiter)
 * 	Nathan Roy		(nroy)
 * 
 * of Worcester Polytechnic Institute,
 * 
 * for our dreamboat, Gary Pollice's OOA&D class.
 *
 * The program is provided under the terms and conditions of
 * the Eclipse Public License Version 1.0 ("EPL"). A copy of the EPL
 * is available at http://www.eclipse.org/org/documents/epl-v10.php.
 * The software is provided under the Copyright, 2007.
 */
package edu.wpi.ari.glados.gui;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class GLaDOSStatusBar extends JPanel {

	private static final long serialVersionUID = 1L;

	private static GLaDOSStatusBar singleton;

	
	public static GLaDOSStatusBar getInstance() {
		if (singleton == null) {
			singleton = new GLaDOSStatusBar();
		}

		return singleton;
	}

	private JComponent current;

	private GLaDOSStatusBar() {
		setOpaque(false);
	}

	public void setStatusBar(JComponent c) {
		if (current != null) {
			remove(current);
		}
		current = c;
		add(c);

		repaint();
		invalidate();
	}

	public void setStatusBar(String s) {
		setStatusBar(new JLabel(s));
	}
}
