package edu.wpi.ari.glados.gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;

import net.miginfocom.swing.MigLayout;

import com.l2fprod.common.swing.JButtonBar;

import edu.wpi.ari.glados.GDriver;
import edu.wpi.ari.glados.slam.SLAMFrame;

public class GUIManager {
	
	private GDriver driver;
	
	private GLaDOSFrame frame;
	
	private JButtonBar toolbar;
	private ButtonGroup group = new ButtonGroup();
	private SLAMFrame slam;
	
	
	public GUIManager(GDriver d, SLAMFrame sp) {
		driver = d;
		slam = sp;
	}
	
	public void initGUI(Dimension d) {
		frame = new GLaDOSFrame(d);
		toolbar = new JButtonBar(JButtonBar.HORIZONTAL);
		
		frame.getContentPane().setLayout(new MigLayout());
		
		frame.getContentPane().add(toolbar, "dock north");
		frame.getContentPane().add(driver.getVisionManager().getLeft());
		frame.getContentPane().add(driver.getVisionManager().getRight(), "span");
		frame.getContentPane().add(driver.getVisionManager().getRight(), "span");
		
		addButton("Piolt", "images/pilot.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// put the controller manager here
			}
		});
		addButton("Video", "images/video.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				driver.getVisionManager().connect();
			}
		});
		addButton("INS", "images/wiimote.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				driver.getINSManager().connect();
			}
		});
		addButton("Clear Log", "images/log.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				slam.clearDataLog();
			}
		});
		addButton("Save Log", "images/save.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				slam.saveDataLog();
			}
		});
		addButton("Set Scaling", "images/manual.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				slam.setScaleDialog();
			}
		});
		addButton("Set Coords", "images/manual.png", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				slam.fixCoordDialog();
			}
		});
	}
	
	private void addButton(String title, String url, ActionListener al) {
		JButton button = new JButton(title, new ImageIcon(url));
		button.addActionListener(al);
		
		toolbar.add(button);
		group.add(button);
	}
}
