package edu.wpi.ari.glados.ins;

import javax.vecmath.Vector3d;

/**
 * Implementing classes will be given an update from the INS when the update
 * is available 
 * 
 * @author robert breznak
 */
public interface INSObserver {
	/**
	 * Called when there is an INS update. 
	 * Contains the new location and velocity from 0,0 which is the previous
	 * position
	 * 
	 * @param velocity - 3D vector in translational space, units in meters
	 * @param yaw - yaw of robot over last timestep in radians
	 */
	public void INSReceivedValues(Vector3d step, double yaw);
}

