package edu.wpi.ari.glados.mplatform;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

//import edu.wpi.rbreznak.GLaDOS.GLaDOS;

/**
 * Manages the mobile base
 * @author robertbreznak
 *
 */


public class MPlatformManager {
	protected String host;
	protected int port;
	protected Socket server;
	protected PrintWriter outsock;
	
	public MPlatformManager(String host, int port) {
		this.host = host;
		this.port = port;
	}
	
	public void connect() throws UnknownHostException, IOException {
		try {
			System.out.println("Connecting to: " + this.host + ":" + this.port);
			server = new Socket(this.host , this.port);
			outsock = new PrintWriter(server.getOutputStream(), true);
		} catch (UnknownHostException e) {
			System.err.println("Gateway Connection Errror: Unknown Host");
			throw e;
		} catch (IOException e) {
			System.err.println("Gateway Connection Error: IO Error");
			throw e;
		}
		System.out.println("Connected to Pilot");
	}
	
	public void disconnect(){
		try {
			server.close();
		} catch (IOException e) {
			System.err.println("Couldn't close socket. Already closed?");
		}
	}
	
	private byte[] convertFromHex(String cmd){
		byte[] bytes = new byte[cmd.length() / 2];
		for (int i = 0; i < bytes.length; i++) {
		   bytes[i] = (byte) Integer.parseInt(cmd.substring(2*i, 2*i+2), 16);
		}
		return bytes;
	}
	protected void writeCommand(String command ) throws IOException{
		outsock.flush();
		outsock.write(command);
		outsock.flush();
	}
	
	public void goForward(){
		try {
			writeCommand("8900FF7FFF");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void goBackward(){
		try {
			writeCommand("89FF017FFF");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void goLeft(){
		try {
			writeCommand("8900FF0001");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void goRight(){
		try {
			writeCommand("8900FFFFFF");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void goStop(){
		try {
			writeCommand("8900000000");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String [] args){
		MPlatformManager m = new MPlatformManager("crenshaw.wifi.wpi.edu", 2727);
		try {
			m.connect();
		} catch (UnknownHostException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		m.goLeft();
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		m.goRight();
		
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		m.disconnect();
	}
}
