package edu.wpi.ari.glados.network;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

public abstract class SensorConnection extends Thread {
	private String host;
	private int port;
	private Socket socket;
	
	/**
	 * Connect to the server
	 * 
	 * @return true if the connection was successful, false otherwise
	 * @throws IOException 
	 * @throws UnknownHostException 
	 */
	public void connect() throws UnknownHostException, IOException
	{
		socket = new Socket(host, port);
	}
	
	public void disconnect() {
		try {
			if(socket.isConnected()) {
				socket.close();
			}
		} catch (IOException e) {
			// 
		}
	}
	
	public Socket getConnection() {
		return socket;
	}
	
	/**
	 * @return the host
	 */
	public String getHost() {
		return host;
	}
	/**
	 * @param host the host to connect to
	 */
	public void setHost(String host) {
		this.host = host;
	}
	/**
	 * @return the port
	 */
	public int getPort() {
		return port;
	}
	/**
	 * @param port the port to set
	 */
	public void setPort(int port) {
		this.port = port;
	}
	
	
}
