package edu.wpi.ari.glados.slam;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 * Allows for loading and saving of a file log data
 * 
 * @author Alex Cunningham
 *
 */
public class SLAMfile implements Serializable {

	private static final long serialVersionUID = 1L;

	protected Vector<Stim> data; 
	
	public SLAMfile(){
		this.data = new Vector<Stim>();
	}
	
	// Access methods
	
	public void addStim(Stim stim){
		this.data.add(stim);
	}
	
	public void clear(){
		this.data.clear();
	}
	
	public Stim getStim(int i){
		return this.data.get(i);
	}
	
	public int getNumStims(){
		return this.data.size();
	}
	
	// File access functions
	
	public static void saveLog(SLAMfile slam, File file, SLAMFrame frame){
		ObjectOutputStream out = null;
		
		try {
			out = new ObjectOutputStream(
					new BufferedOutputStream(
							new FileOutputStream(file)));
			frame.printToConsole("Saving " + slam.data.size() + " Stims...");
			out.writeObject(slam.data);
			out.close();
		} catch (FileNotFoundException e) {
			JOptionPane.showMessageDialog(frame, "Unavailable File", "Logging Error", JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(frame, "IOException", "Error!", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}

	}
	
	public static SLAMfile openLog(String filename, JFrame frame){
		SLAMfile log = new SLAMfile();
		
		ObjectInputStream in = null;
		
		try {
			in = new ObjectInputStream(
					new BufferedInputStream(
							new FileInputStream(filename)));
			Object input = in.readObject();
			if (input instanceof Vector){
				//log.data = (Vector<Stim>)input;
			}
			in.close();
		} catch (FileNotFoundException e) {
			JOptionPane.showMessageDialog(frame, "Unavailable File", "Logging Error", JOptionPane.WARNING_MESSAGE);
			e.printStackTrace();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(frame, "IOException", "Error!", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			JOptionPane.showMessageDialog(frame, "ClassNotFound Exception", "Error!", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}
		
		if (log == null){
			JOptionPane.showMessageDialog(frame, "File Open Failed", "Error", JOptionPane.WARNING_MESSAGE);
		}
		
		return log;
	}
	
	
	
	
	

}
