package edu.wpi.ari.glados.test;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.vecmath.Vector3d;

import edu.wpi.ari.glados.vision.VisionManager;
import edu.wpi.ari.glados.vision.VisionObserver;

public class GGDriver extends JFrame implements VisionObserver{

	private static final long serialVersionUID = 1L;
	
	private VisionManager vm;
	
	public static void main(String [] args) {
		new GGDriver();
	}
	
	public GGDriver() {
		// set the frame title
		super("GLaDOS");
		
		// exit the app when the window is closed
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		init();
		
		// set the size, center, and show the frame
		setSize(new Dimension(800, 350));
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	public void init() {
		final JButton btnConnect = new JButton("Connect");
		
		vm = new VisionManager("crenshaw.wifi.wpi.edu", 7777, 8888, 30, new Dimension(240, 320));
		vm.addListener(this);
		
		btnConnect.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				vm.connect();
				btnConnect.setEnabled(false);
			}
			
		});
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(vm.getLeft(), BorderLayout.WEST);
		getContentPane().add(vm.getRight(), BorderLayout.EAST);
		getContentPane().add(btnConnect, BorderLayout.SOUTH);
	}

	public void VisionReceivedValues(Vector<Vector3d> points) {
		System.out.println("Number of Points: " + points.size());
	}
}
