package edu.wpi.ari.glados.test;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.vecmath.Vector3d;

import edu.wpi.ari.glados.ins.INSManager;
import edu.wpi.ari.glados.ins.INSObserver;

public class INSTest extends JFrame implements INSObserver{

	private static final long serialVersionUID = 1L;
	
	private INSManager im;
	private JTextArea log;
	
	public static void main(String [] args) {
		new INSTest();
	}
	
	public INSTest() {
		// set the frame title
		super("GLaDOS INS Test");
		
		// exit the app when the window is closed
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		init();
		
		// set the size, center, and show the frame
		setSize(new Dimension(300, 300));
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	public void init() {
		final JButton btnConnect = new JButton("Connect");
		
		log = new JTextArea();
		
		im = new INSManager("localhost", 4445);
		im.addListener(this);
		
		btnConnect.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				log.append("Connecting...\n");
				im.connect();
				log.append("Connected.\n");
				btnConnect.setEnabled(false);
			}
			
		});
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(log, BorderLayout.CENTER);
		getContentPane().add(btnConnect, BorderLayout.SOUTH);
	}

	public void VisionReceivedValues(Vector<Vector3d> points) {
		System.out.println("Number of Points: " + points.size());
	}

	public void INSReceivedValues(Vector3d step, double yaw) {
		log.append("Data Received: " + step.toString() + "@" + yaw + "\n");
	}
}
