package edu.wpi.ari.glados.vision;

import java.util.Vector;

import javax.vecmath.Vector3d;

/**
 * Implementing classes will be given an update from the INS when the update
 * is available 
 * 
 * @author robert breznak
 */
public interface VisionObserver {
	/**
	 * Called when there is an INS update. 
	 * Contains the new location and velocity from 0,0 which is the previous
	 * position
	 * 
	 * @param velocity
	 */
	public void VisionReceivedValues(Vector<Vector3d> points);
}

