package edu.wpi.ari.glados.ins;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class GINSServer {
	private JFrame frame;

	private JPanel applicationPanel;
	private JPanel buttonPanel;
	
	private JButton shutdownButton;
	private JButton startButton;
	private JButton pingButton;
	private JButton reconnButton;
	
	private JLabel connStatusLabel;
	
	private INSController controler;
	
	public void setINSControler(INSController ctl) {
		controler = ctl;
	}
	
	public void disableButtons() {
		pingButton.setEnabled(false);
		shutdownButton.setEnabled(false);
		startButton.setEnabled(false);
		reconnButton.setEnabled(false);
	}
	
	public GINSServer() {
		frame = new JFrame();
		frame.setTitle("Glados INS Server");
		
		initComponents();
		
		disableButtons();
		
		frame.setContentPane(buttonPanel);
		
		frame.setVisible(true);
		frame.pack();
	}
	
	public void setConnected(boolean c) {
		pingButton.setEnabled(c);
		shutdownButton.setEnabled(c);
		startButton.setEnabled(c);
		reconnButton.setEnabled(c);
	}
	
	private void initComponents() {	
		applicationPanel = new JPanel();
		buttonPanel = new JPanel();
		
		shutdownButton = new JButton();
		startButton = new JButton();
		pingButton = new JButton();
		reconnButton = new JButton();
		
		connStatusLabel = new JLabel("Starting...");

		buttonPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

		buttonPanel.setAlignmentX(0.0F);
		buttonPanel.setAlignmentY(0.0F);
		buttonPanel.setMaximumSize(new java.awt.Dimension(470, 39));
		buttonPanel.setMinimumSize(new java.awt.Dimension(470, 39));
		buttonPanel.setPreferredSize(new java.awt.Dimension(470, 39));

		startButton.setText("Start Data");
		startButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				startButtonActionPerformed(evt);
			}
		});

		buttonPanel.add(startButton);
		
		pingButton.setText("Ping Spot");
		pingButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				pingButtonActionPerformed(evt);
			}
		});

		buttonPanel.add(pingButton);
		
		shutdownButton.setText("Shutdown");
		shutdownButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				shutdownButtonActionPerformed();
			}
		});
		
		buttonPanel.add(shutdownButton);

		reconnButton.setText("Reconnect");
		reconnButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				reconnButtonActionPerformed(evt);
			}
		});

		buttonPanel.add(reconnButton);
		
		applicationPanel.setLayout(new BorderLayout());
		
		applicationPanel.add("Center", buttonPanel);
		applicationPanel.add("South", connStatusLabel);
	}
	
	private void shutdownButtonActionPerformed() {
		controler.quit();
	}

	private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {
		controler.startSpot();
	}
	
	private void pingButtonActionPerformed(java.awt.event.ActionEvent evt) {
		controler.ping();
	}

	private void reconnButtonActionPerformed(ActionEvent evt) {
		controler.reconnect();
	}
}
